VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormColors 
   Caption         =   "Color-Converter 2.0"
   ClientHeight    =   4980
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4320
   OleObjectBlob   =   "FormColors.frx":0000
   ShowModal       =   0   'False
End
Attribute VB_Name = "FormColors"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const CC_RGBINIT = &H1
Const CC_FULLOPEN = &H2
Const CC_PREVENTFULLOPEN = &H4
Const CC_SHOWHELP = &H8
Const CC_ENABLEHOOK = &H10
Const CC_ENABLETEMPLATE = &H20
Const CC_ENABLETEMPLATEHANDLE = &H40
Const CC_SOLIDCOLOR = &H80
Const CC_ANYCOLOR = &H100

Const GMEM_MOVEABLE = &H2
Const GMEM_ZEROINIT = &H40
Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)
Const testtext = "ABDFGILMOQWXYZjklmnopquvw0129YZ"

Private Type ChooseColor
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
Private Declare Function GlobalAlloc Lib "KERNEL32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "KERNEL32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" ( _
         hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

Dim Rrat, Grat, Brat, Rabs, Gabs, Babs
Dim s_hex As String

Private Sub cb_exit_Click()
    Unload FormColors
End Sub

Private Sub UserForm_Initialize()
    Dim cal As Long
   
    lb_sum.AddItem 1
    lb_sum.AddItem 2
    lb_sum.AddItem 4
    lb_sum.AddItem 8
    lb_sum.AddItem 16
    lb_sum.AddItem 17
    lb_sum.AddItem 32
    lb_sum.AddItem 64
    lb_sum.AddItem 128
    lb_sum.AddItem 256
    lb_sum.AddItem 512
    lb_sum.AddItem 1024
    lb_sum.AddItem 2048
    lb_sum.AddItem 4096
    lb_sum.AddItem 8192
    lb_sum.AddItem 16384
    lb_sum.AddItem 32768
    lb_sum.AddItem 65536
    lb_sum.ListIndex = 17
    lb_sum.ControlTipText = "65536 ~ blue / 256 ~ green / 1 ~ red"
    
    TextBox2.Text = testtext + Chr(13) + testtext
    
    'tb_pr.Text = "0,8"
    'tb_pg.Text = "0,4"
    'tb_pb.Text = "0,8"
    tb_rr.Text = "0"
    tb_rg.Text = "0"
    tb_rb.Text = "0"
    
    im_1.BackColor = 0
    im_2.BackColor = 16777215 'RGB(255, 255, 255)
End Sub

Sub calc_colors()
    Dim cal As Long
    
    On Error GoTo error_proc
    lbl_error.Caption = ""
    If tb_pr.Text <> "" And tb_pg.Text <> "" And tb_pb.Text <> "" Then
        Rabs = tb_pr.Text
        Gabs = tb_pg.Text
        Babs = tb_pb.Text
        
        Rrat = Int(Rabs * 255)
        Grat = Int(Gabs * 255)
        Brat = Int(Babs * 255)
        If Len(Hex(Rrat)) < 2 Then s_hex = "0" + Hex(Rrat) Else s_hex = Hex(Rrat)
        If Len(Hex(Grat)) < 2 Then s_hex = s_hex + "0" + Hex(Grat) Else s_hex = s_hex + Hex(Grat)
        If Len(Hex(Brat)) < 2 Then s_hex = s_hex + "0" + Hex(Brat) Else s_hex = s_hex + Hex(Brat)
    ElseIf tb_rr.Text <> "" And tb_rg.Text <> "" And tb_rb.Text <> "" Then
        Rrat = tb_rr.Text
        Grat = tb_rg.Text
        Brat = tb_rb.Text
        
        Rabs = Rrat / 255
        Gabs = Grat / 255
        Babs = Brat / 255
        If Len(Hex(Rrat)) < 2 Then s_hex = "0" + Hex(Rrat) Else s_hex = Hex(Rrat)
        If Len(Hex(Grat)) < 2 Then s_hex = s_hex + "0" + Hex(Grat) Else s_hex = s_hex + Hex(Grat)
        If Len(Hex(Brat)) < 2 Then s_hex = s_hex + "0" + Hex(Brat) Else s_hex = s_hex + Hex(Brat)
    ElseIf tb_hex.Text <> "" Then
        s_hex = tb_hex.Text
        Rrat = CDec("&H" + Mid(s_hex, 1, 2))
        Grat = CDec("&H" + Mid(s_hex, 3, 2))
        Brat = CDec("&H" + Mid(s_hex, 5, 2))
        Rabs = Rrat / 255
        Gabs = Grat / 255
        Babs = Brat / 255
        'Format
'        Rabs = Round(Rrat / 255, 6)
'        Gabs = Round(Grat / 255, 6)
'        Babs = Round(Brat / 255, 6)
    ElseIf tb_int.Text <> "" Then
        cal = Val(tb_int.Text)
        Brat = cal \ 65536
        cal = cal - Brat * 65536
        Grat = cal \ 256
        Rrat = cal - Grat * 256
        
        Rabs = Rrat / 255
        Gabs = Grat / 255
        Babs = Brat / 255
        If Len(Hex(Rrat)) < 2 Then s_hex = "0" + Hex(Rrat) Else s_hex = Hex(Rrat)
        If Len(Hex(Grat)) < 2 Then s_hex = s_hex + "0" + Hex(Grat) Else s_hex = s_hex + Hex(Grat)
        If Len(Hex(Brat)) < 2 Then s_hex = s_hex + "0" + Hex(Brat) Else s_hex = s_hex + Hex(Brat)
    Else: lbl_error.Caption = "error"
    End If

    tb_npr.Text = Rabs
    tb_npg.Text = Gabs
    tb_npb.Text = Babs
    tb_nrr.Text = Rrat
    tb_nrg.Text = Grat
    tb_nrb.Text = Brat
    tb_nhex.Text = s_hex
    If Len(Hex(Brat)) < 2 Then s_hex = "0" + Hex(Brat) Else s_hex = Hex(Brat)
    If Len(Hex(Grat)) < 2 Then s_hex = s_hex + "0" + Hex(Grat) Else s_hex = s_hex + Hex(Grat)
    If Len(Hex(Rrat)) < 2 Then s_hex = s_hex + "0" + Hex(Rrat) Else s_hex = s_hex + Hex(Rrat)
    tb_nhex2.Text = s_hex
    tb_nint.Text = Rrat + Grat * 256 + Brat * 65536 ' CDec("&H" + s_hex)
    
    tb_hue.Text = Str(gethue(Rrat + Grat * 256 + Brat * 65536))
    
    If OptionButton1.Value Then
        TextBox2.BackColor = RGB(Rrat, Grat, Brat)
        im_1.BackColor = RGB(Rrat, Grat, Brat)
    ElseIf OptionButton2.Value Then
        TextBox2.ForeColor = RGB(Rrat, Grat, Brat)
        im_2.BackColor = RGB(Rrat, Grat, Brat)
    End If
    TextBox2.SelStart = 0
    TextBox2.SelLength = Len(testtext)
    
    Exit Sub
error_proc:
    lbl_error.Caption = "ERROR: no color"
End Sub

Private Sub sethue(direc As Integer)
    Dim r As Long, g As Long, b As Long
    Dim rr As Long, gr As Long, br As Long
    
    r = tb_rr.Text
    g = tb_rg.Text
    b = tb_rb.Text
    
    If r >= 255 And g >= 255 And b >= 255 And direc = 1 Then
        r = 0
        g = 0
        b = 0
    ElseIf r <= 0 And g <= 0 And b <= 0 And direc = -1 Then
        r = 255
        g = 255
        b = 255
    End If
    
    rr = r / 256 * 100 * direc
    gr = g / 256 * 100 * direc
    br = b / 256 * 100 * direc
        
    If rr <= 100 Then r = r + Round(rr / 100 + direc) ' direc 'CInt((r + r / 3) / 100 * 256)
    If gr <= 100 Then g = g + Round(gr / 100 + direc) ' direc 'CInt((g + g / 3) / 100 * 256)
    If br <= 100 Then b = b + Round(br / 100 + direc) ' direc 'CInt((b - b / 3) / 100 * 256)
    
    If r < 0 Then r = 0
    If g < 0 Then g = 0
    If b < 0 Then b = 0
    If r > 255 Then r = 255
    If g > 255 Then g = 255
    If b > 255 Then b = 255
    
    tb_rr.Text = Str(r)
    tb_rg.Text = Str(g)
    tb_rb.Text = Str(b)
End Sub

Function gethue(cal As Long) As Long
    Dim r As Long, g As Long, b As Long
    b = cal \ 65536
    cal = cal - b * 65536
    g = cal \ 256
    r = cal - g * 256
    
    If r > 0 Then r = r / 256 * 100
    If g > 0 Then g = g / 256 * 100
    If b > 0 Then b = b / 256 * 100
    
    gethue = CLng(r / 3 + g / 3 + b / 3)
End Function

Private Sub CommandButton1_Click()
    tb_pr.Text = tb_npr.Text
    tb_pg.Text = tb_npg.Text
    tb_pb.Text = tb_npb.Text
End Sub

Private Sub CommandButton2_Click()
    tb_rr.Text = tb_nrr.Text
    tb_rg.Text = tb_nrg.Text
    tb_rb.Text = tb_nrb.Text
End Sub

Private Sub CommandButton3_Click()
    tb_hex.Text = tb_nhex.Text
End Sub

Private Sub CommandButton4_Click()
    tb_int.Text = tb_nint.Text
End Sub

Private Sub sp_pr_SpinUp()
    If chk2 Then tb_pr.Text = Replace(Str(Val(Replace(tb_pr.Text, ",", ".")) + 0.01), ".", ",") _
    Else tb_pr.Text = Replace(Str(Val(Replace(tb_pr.Text, ",", ".")) + 0.1), ".", ",")
    If Val(Replace(tb_pr.Text, ",", ".")) > 1 Then tb_pr.Text = 0
End Sub
Private Sub sp_pr_SpinDown()
    If chk2 Then tb_pr.Text = Replace(Str(Val(Replace(tb_pr.Text, ",", ".")) - 0.01), ".", ",") _
    Else tb_pr.Text = Replace(Str(Val(Replace(tb_pr.Text, ",", ".")) - 0.1), ".", ",")
    If Val(Replace(tb_pr.Text, ",", ".")) < 0 Then tb_pr.Text = 1
End Sub

Private Sub sp_pg_SpinUp()
    If chk2 Then tb_pg.Text = Replace(Str(Val(Replace(tb_pg.Text, ",", ".")) + 0.01), ".", ",") _
    Else tb_pg.Text = Replace(Str(Val(Replace(tb_pg.Text, ",", ".")) + 0.1), ".", ",")
    If Val(Replace(tb_pg.Text, ",", ".")) > 1 Then tb_pg.Text = 0
End Sub
Private Sub sp_pg_SpinDown()
    If chk2 Then tb_pg.Text = Replace(Str(Val(Replace(tb_pg.Text, ",", ".")) - 0.01), ".", ",") _
    Else tb_pg.Text = Replace(Str(Val(Replace(tb_pg.Text, ",", ".")) - 0.1), ".", ",")
    If Val(Replace(tb_pg.Text, ",", ".")) < 0 Then tb_pg.Text = 1
End Sub

Private Sub sp_pb_SpinUp()
    If chk2 Then tb_pb.Text = Replace(Str(Val(Replace(tb_pb.Text, ",", ".")) + 0.01), ".", ",") _
    Else tb_pb.Text = Replace(Str(Val(Replace(tb_pb.Text, ",", ".")) + 0.1), ".", ",")
    If Val(Replace(tb_pb.Text, ",", ".")) > 1 Then tb_pb.Text = 0
End Sub
Private Sub sp_pb_SpinDown()
    If chk2 Then tb_pb.Text = Replace(Str(Val(Replace(tb_pb.Text, ",", ".")) - 0.01), ".", ",") _
    Else tb_pb.Text = Replace(Str(Val(Replace(tb_pb.Text, ",", ".")) - 0.1), ".", ",")
    If Val(Replace(tb_pb.Text, ",", ".")) < 0 Then tb_pb.Text = 1
End Sub

Private Sub sp_rr_SpinUp()
    If chk17 Then
        tb_rr.Text = Replace(Str(Val(Replace(tb_rr.Text, ",", ".")) + 17), ".", ",")
    Else
        tb_rr.Text = Replace(Str(Val(Replace(tb_rr.Text, ",", ".")) + 1), ".", ",")
    End If
    If Val(Replace(tb_rr.Text, ",", ".")) > 255 Then tb_rr.Text = 0
End Sub
Private Sub sp_rr_SpinDown()
    If chk17 Then
        tb_rr.Text = Replace(Str(Val(Replace(tb_rr.Text, ",", ".")) - 17), ".", ",")
    Else
        tb_rr.Text = Replace(Str(Val(Replace(tb_rr.Text, ",", ".")) - 1), ".", ",")
    End If
    If Val(Replace(tb_rr.Text, ",", ".")) < 0 Then tb_rr.Text = 255
End Sub

Private Sub sp_rg_SpinUp()
    If chk17 Then
        tb_rg.Text = Replace(Str(Val(Replace(tb_rg.Text, ",", ".")) + 17), ".", ",")
    Else
        tb_rg.Text = Replace(Str(Val(Replace(tb_rg.Text, ",", ".")) + 1), ".", ",")
    End If
    If Val(Replace(tb_rg.Text, ",", ".")) > 255 Then tb_rg.Text = 0
End Sub
Private Sub sp_rg_SpinDown()
    If chk17 Then
        tb_rg.Text = Replace(Str(Val(Replace(tb_rg.Text, ",", ".")) - 17), ".", ",")
    Else
        tb_rg.Text = Replace(Str(Val(Replace(tb_rg.Text, ",", ".")) - 1), ".", ",")
    End If
    If Val(Replace(tb_rg.Text, ",", ".")) < 0 Then tb_rg.Text = 255
End Sub

Private Sub sp_rb_SpinUp()
    If chk17 Then
        tb_rb.Text = Replace(Str(Val(Replace(tb_rb.Text, ",", ".")) + 17), ".", ",")
    Else
        tb_rb.Text = Replace(Str(Val(Replace(tb_rb.Text, ",", ".")) + 1), ".", ",")
    End If
    If Val(Replace(tb_rb.Text, ",", ".")) > 255 Then tb_rb.Text = 0
End Sub
Private Sub sp_rb_SpinDown()
    If chk17 Then
        tb_rb.Text = Replace(Str(Val(Replace(tb_rb.Text, ",", ".")) - 17), ".", ",")
    Else
        tb_rb.Text = Replace(Str(Val(Replace(tb_rb.Text, ",", ".")) - 1), ".", ",")
    End If
    If Val(Replace(tb_rb.Text, ",", ".")) < 0 Then tb_rb.Text = 255
End Sub


Private Sub SpinButtonHUE_SpinUp()
    tb_hue.Text = Replace(Str(Val(Replace(tb_hue.Text, ",", ".")) + 1), ".", ",")
    If Val(Replace(tb_hue.Text, ",", ".")) > 100 Then tb_hue.Text = 0
    If tb_rr.Text <> "" And tb_rg.Text <> "" And tb_rb.Text <> "" Then
        sethue (1)
    End If
End Sub
Private Sub SpinButtonHUE_SpinDown()
    tb_hue.Text = Replace(Str(Val(Replace(tb_hue.Text, ",", ".")) - 1), ".", ",")
    If Val(Replace(tb_hue.Text, ",", ".")) < 0 Then tb_hue.Text = 100
    If tb_rr.Text <> "" And tb_rg.Text <> "" And tb_rb.Text <> "" Then
        sethue (-1)
    End If
End Sub

Private Sub SpinButtonInt_SpinUp()
    If tb_int.Text <> "" Then
        tb_int.Text = Val(tb_int) + Val(lb_sum.Text)
        If Val(tb_int.Text) > 16777215 Then tb_int.Text = 0
    End If
End Sub

Private Sub SpinButtonInt_SpinDown()
    If tb_int.Text <> "" Then
        tb_int.Text = Val(tb_int) - Val(lb_sum.Text)
        If Val(tb_int.Text) < 0 Then tb_int.Text = 16777215
    End If
End Sub

Private Sub tb_int_Change()
    If tb_int.Text <> "" Then
        Call del_rgb
        Call del_prom
        tb_hex.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_hex_Change()
    If tb_hex.Text <> "" Then
        Call del_rgb
        Call del_prom
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_pb_Change()
    If tb_pb.Text <> "" Then
        Call del_rgb
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_pg_Change()
    If tb_pg.Text <> "" Then
        Call del_rgb
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_pr_Change()
    If tb_pr.Text <> "" Then
        Call del_rgb
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_rb_Change()
    If tb_rb.Text <> "" Then
        Call del_prom
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_rg_Change()
    If tb_rg.Text <> "" Then
        Call del_prom
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Private Sub tb_rr_Change()
    If tb_rr.Text <> "" Then
        Call del_prom
        tb_hex.Text = ""
        tb_int.Text = ""
        Call calc_colors
    End If
End Sub

Sub del_prom()
    tb_pr.Text = ""
    tb_pg.Text = ""
    tb_pb.Text = ""
End Sub

Sub del_rgb()
    tb_rr.Text = ""
    tb_rg.Text = ""
    tb_rb.Text = ""
End Sub

Private Sub OptionButton1_Click()
    setRGBVals im_1.BackColor
    Call calc_colors
End Sub

Private Sub OptionButton2_Click()
    setRGBVals im_2.BackColor
    Call calc_colors
End Sub

Function setRGBVals(c As Long) As Long
    Dim r As Long, g As Long, b As Long
    b = c \ 65536
    c = c - b * 65536
    g = c \ 256
    r = c - g * 256
    
    tb_rr.Text = Str(r)
    tb_rg.Text = Str(g)
    tb_rb.Text = Str(b)
    Call calc_colors
End Function

Private Sub im_1_Click()
    OptionButton1.Value = True
End Sub
Private Sub im_1_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    Dim newc As Long
    Call im_1_Click
    newc = GetColor(im_1.BackColor)
    If newc >= 0 Then
        im_1.BackColor = newc
        setRGBVals im_1.BackColor
        Call calc_colors
    End If
End Sub

Private Sub im_2_Click()
    OptionButton2.Value = True
End Sub
Private Sub im_2_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    Dim newc As Long
    Call im_2_Click
    newc = GetColor(im_2.BackColor)
    If newc >= 0 Then
        im_2.BackColor = newc
        setRGBVals im_2.BackColor
        Call calc_colors
    End If
End Sub

Private Sub cb_swap_Click()
    Dim zw As Long
    zw = im_1.BackColor
    im_1.BackColor = im_2.BackColor
    im_2.BackColor = zw
    zw = TextBox2.ForeColor
    TextBox2.ForeColor = TextBox2.BackColor
    TextBox2.BackColor = zw
    If OptionButton1.Value Then
        setRGBVals im_1.BackColor
    Else
        setRGBVals im_2.BackColor
    End If
    Call calc_colors
End Sub

Function GetColor(initcol As Long)
    'display the color dialog box
    
    Dim tChooseColor As ChooseColor
    Dim alCustomColors(15) As Long
    Dim lCustomColorSize As Long
    Dim lCustomColorAddress As Long
    Dim lMemHandle As Long
    Dim bCancelError As Boolean    'internal buffer for CancelError property
    Dim lApiReturn As Long          'internal buffer for APIReturn property
    Dim lColor As Long             'internal buffer for Color property
    
    Dim n As Integer
        
    lApiReturn = 0  'APIReturn property
    
    'lpCustColors As Long
    ' Fill custom colors array with all white
    For n = 0 To UBound(alCustomColors)
        alCustomColors(n) = &HFFFFFF
    Next
    ' Get size of memory needed for custom colors
    lCustomColorSize = Len(alCustomColors(0)) * 16
    ' Get a global memory block to hold a copy of the custom colors
    lMemHandle = GlobalAlloc(GHND, lCustomColorSize)
    
    If lMemHandle = 0 Then
        Exit Function
    End If
    ' Lock the custom color's global memory block
    lCustomColorAddress = GlobalLock(lMemHandle)
    If lCustomColorAddress = 0 Then
        Exit Function
    End If
    ' Copy custom colors to the global memory block
    Call CopyMemory(ByVal lCustomColorAddress, alCustomColors(0), lCustomColorSize)
 
    tChooseColor.lpCustColors = lCustomColorAddress
    
    tChooseColor.lStructSize = Len(tChooseColor)
    tChooseColor.rgbResult = initcol
    tChooseColor.flags = CC_RGBINIT Or CC_FULLOPEN
    tChooseColor.hwndOwner = Application.hwnd ' if used in VBA
    'tChooseColor.hwndOwner = FormColors.hwnd ' if used in VB6
       
    '***    call the ChooseColor API function
    lApiReturn = ChooseColor(tChooseColor)
    Select Case lApiReturn
        Case 0  'user canceled
            GetColor = -1
        Case 1  'user selected a color
            'update property buffer
            lColor = tChooseColor.rgbResult
            GetColor = lColor
        Case Else   'an error occured
            GetColor = -1
    End Select
End Function
